// comp1.cpp: implementation of the comp1 class.
//
//////////////////////////////////////////////////////////////////////

#include "comp1.h"


int comp1::the_move(state board,int type)
{
	//this function gets state board and integer type
	//type is the level of the minimax
	//the board is the board
	//it returns the move
	
	
	int j;//loap parameter
	int board1[board_length][board_high];	//board array 
	for (int i=0;i<board_length;++i)		//copy board to board1
		for	(j=0;j<board_high;++j)
			board1[i][j]=board.value(i,j);
	state board2;
	board2.copy(board1);//copy board1 to board2
	

	int line;
	minimax(board2,line,type);//find the move
	return line;

}

int comp1::minimax(state board, int &column, int level)
{
	//this function gets board  empty parameter and level
	//it returns the value of the expected future board
	//in the empy parmeter (column) return the best move

	int i;					//loap parmeter
	int maximum=-32000;		//low value
	int scr;				//score paremeter
	rules rule;				//parameter of the rules	
	the_list list_1;		//list of the options that possible
	rule.update_high(board);//update high of rules
	rule.options(list_1);	//update list of possible moves;
	if (level==1||rule.the_turn(board)>board_length*board_high-2)//stop condition
	{



		for ( i=0;i<board_length;++i)//from 0 to board length -1
		{
			if (list_1.possible(i)==1)//if posible
			{
				board.move(i,rule.the_high(i),rule.the_turn(board)%2+1);//move
				rule.update_high(board);//update rules
				
				scr=score(board);//score
				
				if (rule.the_turn(board)%2==0)
				{
					scr=scr*(-1);//return minus the result
				}
				
				if (scr>maximum)//if bigger than maximum
				{
					maximum=scr;//update maximum
					column=i;//update column
				}
				board.redo(i,rule.the_high(i)-1);//redo
				rule.update_high(board);//update high
				

			}
		}
		
		return	maximum*-1; //return
	}
	int x;//parameter

	for (i=0;i<board_length;++i) //from 0 to board length -1
	{
		if (list_1.possible(i)==1)//if possible
		{
			board.move(i,rule.the_high(i),rule.the_turn(board)%2+1);//move
			rule.update_high(board);//update high
			
			if (rule.won(board)==0)//if not win
			{
				scr=minimax(board,x,level-1);//reqursy
				if (scr>maximum)//if better
				{
					maximum=scr;//put in maximum
					column =i;//update column
				}
				board.redo(i,rule.the_high(i)-1);//redo
				rule.update_high(board);//update high
			}
			else	//if win
			{
				board.redo(i,rule.the_high(i)-1);//redo
				rule.update_high(board);//update high
				column=i;//update column
				maximum= 30001;//maximum
				return maximum*-1;//return
			}




		}
	}
	return maximum*-1;		//return maximum

	


}

int comp1::score(state board)
{
	//this function score a state of a board
	//it gets a board and returns the value of the board
	int s[2];//scores of player1,2
	s[0]=0;
	s[1]=0;
	int z;//parameter
	rules rule;//parameter
	rule.update_high(board);//update high
	int win=rule.won(board);//update if there is a winner
	if (win==1)//check if there are winners
		s[0]=s[0]+1000;
	if (win==2)
		s[1]=s[1]+1000;
	int j,i,l;//loap parameters
	for (int k=0;k<2;++k)//from 0 to 1
	{
		//checks lines
		for (i=0;i<board_length/2+1;++i)
		{
			for (j=0;j<board_high;++j)
			{
				z=0;
				for (l=0;l<in_one_line;++l)
				{
					if (board.value(i+l,j)==k+1)
						z++;
					if (board.value(i+l,j)!=0&&board.value(i+l,j)!=k+1)
						z=z-in_one_line;
					
					
							
				}
				if (z>0)
					s[k]=s[k]+z*z*z;
			}
		}
	}
				

	for (k=0;k<2;++k)
	{
		//check columns
		for (i=0;i<board_length;++i)
		{
			for (j=0;j<board_high/2;++j)
			{
				z=0;
				for (l=0;l<in_one_line;++l)
				{
					if (board.value(i,j+l)==k+1)
						z++;
					if (board.value(i,j+l)!=0&&board.value(i,j+l)!=k+1)
						z=z-in_one_line;
					
					
							
				}
				if (z>0)
					s[k]=s[k]+z*z*z;
				




			}
		}
	}


	
	for (k=0;k<2;++k)
	{
		//check ///////////////////////////alchson to righ
		for (i=0;i<board_length/2+1;++i)
		{
			for (j=0;j<board_high/2;++j)
			{
			
				z=0;
				for (l=0;l<in_one_line;++l)
				{
					if (board.value(i+l,j+l)==k+1)
						z++;
					if (board.value(i+l,j+l)!=0&&board.value(i+l,j+l)!=k+1)
						z=z-in_one_line;
					
					
							
				}
				if (z>0)
					s[k]=s[k]+z*z*z;



				
			
			
			
			}
		}
	}

	for (k=0;k<2;++k)
	{
		
		//check /////////////////////////////////alchson to left
		for (i=board_length/2;i<board_length;++i)
		{
			for (j=0;j<board_high/2;++j)
			{
				
				z=0;
				for (l=0;l<in_one_line;++l)
				{
					if (board.value(i-l,j+l)==k+1)
						z++;
					if (board.value(i-l,j+l)!=0&&board.value(i-l,j+l)!=k+1)
						z=z-in_one_line;
					
					
							
				}
				if (z>0)
					s[k]=s[k]+z*z*z;


			}
		}
	}

	return s[0]-s[1]; //return value
}
